<?php
/**
 * Kunena Component
 * @package Kunena.Template.Blue_Eagle
 * @subpackage Topic
 *
 * @copyright (C) 2008 - 2016 Kunena Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.kunena.org
 **/
defined ( '_JEXEC' ) or die ();

$dateshown = $datehover = '';
if ($this->message->modified_time) {
	$datehover = 'title="'.KunenaDate::getInstance($this->message->modified_time)->toKunena('config_post_dateformat_hover').'"';
	$dateshown = KunenaDate::getInstance($this->message->modified_time)->toKunena('config_post_dateformat' ).' ';
}
?>
<div class="jf_ku_post_tools">
	<div class="kmessage-editmarkup-cover hidden-phone">
		<?php if ($this->message->modified_by && $this->config->editmarkup) : ?>
		<span class="kmessage-editmarkup hidden-phone" <?php echo $datehover ?>>
			<?php echo JText::_('COM_KUNENA_EDITING_LASTEDIT') . ': ' . $dateshown . JText::_('COM_KUNENA_BY') . ' ' . $this->message->getModifier()->getLink() . '.'; ?>
			<?php if ($this->message->modified_reason) echo JText::_('COM_KUNENA_REASON') . ': ' . $this->escape ( $this->message->modified_reason ); ?>
		</span>
		<i class="material-icons">info_outline</i>
		<?php endif ?>
	</div>
	<div id="<?php echo intval($this->message->id) ?>" class="jf_ku_post_id">
		<?php echo $this->numLink ?>
	</div>
	<?php if(!JFactory::getUser()->guest) { ?>
	<div class="jf_ku_post_actions">
		<button id="jf_ku_post_action_<?php echo intval($this->message->id) ?>" class="jf_ku_post_action"><svg viewBox="0 0 24 24" style="width:24px;vertical-align:-4px" data-reactid=".0.$=12:0.0.0.1:1.1.1:2.0.0.$touchRipple.1:2:$=10:0"><path d="M12 8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z" data-reactid=".0.$=12:0.0.0.1:1.1.1:2.0.0.$touchRipple.1:2:$=10:0.0"></path></svg></button>
		<ul class="mdl-menu mdl-menu--bottom-right mdl-js-menu" for="jf_ku_post_action_<?php echo intval($this->message->id) ?>">	
			<?php if (empty($this->message_closed)) : ?>
				<li class="mdl-menu__item 1"><?php echo $this->messageButtons->get('edit'); ?></li>
				<li class="mdl-menu__item 2"><?php echo $this->messageButtons->get('moderate'); ?></li>
				<li class="mdl-menu__item 3"><?php echo $this->messageButtons->get('delete'); ?></li>
				<li class="mdl-menu__item 4"><?php echo $this->messageButtons->get('permdelete'); ?></li>
				<li class="mdl-menu__item 5"><?php echo $this->messageButtons->get('undelete'); ?></li>
				<li class="mdl-menu__item 6"><i class="material-icons">publish</i><?php echo $this->messageButtons->get('publish'); ?></li>
			<?php else : ?>
				<li class="mdl-menu__item 7"><?php echo $this->message_closed; ?></li>
				<?php if( !$this->topic->locked ) : ?>
				<li class="mdl-menu__item 1"><?php echo $this->messageButtons->get('edit'); ?></li>
				<li class="mdl-menu__item 2"><?php echo $this->messageButtons->get('moderate'); ?></li>
				<li class="mdl-menu__item 3"><?php echo $this->messageButtons->get('delete'); ?></li>
				<li class="mdl-menu__item 4"><?php echo $this->messageButtons->get('permdelete'); ?></li>
				<li class="mdl-menu__item 5"><?php echo $this->messageButtons->get('undelete'); ?></li>
				<li class="mdl-menu__item 6"><i class="material-icons">publish</i><?php echo $this->messageButtons->get('publish'); ?></li>
				<?php endif ?>
			<?php endif ?>
				
			<?php if (!empty($this->reportMessageLink)) :?>
				<li class="mdl-menu__item 14"><i class="material-icons">report_problem</i><?php echo $this->reportMessageLink ?></li>
				<?php if (!empty($this->ipLink)) : ?>
				<li class="mdl-menu__item 15"><i class="material-icons">fingerprint</i><?php echo $this->ipLink ?></li>
				<?php endif ?>
			<?php endif ?>
		</ul>
	</div>
	<?php } ?>
</div>


<?php if ($this->signatureHtml) : ?>
<div class="kmsgsignature">
	<?php echo $this->signatureHtml ?>
</div>
<?php endif ?>


<div class="jf_ku_post_footer">
	<div class="kmessage-buttons-cover">
		<?php if (empty($this->message_closed)) : ?>
			<?php echo $this->messageButtons->get('quickreply'); ?>
			<?php echo $this->messageButtons->get('reply'); ?>
			<?php echo $this->messageButtons->get('quote'); ?>
		<?php else : ?>
			<?php echo $this->message_closed; ?>
		<?php endif ?>
	</div>

	<?php if($this->messageButtons->get('thankyou')): ?>
		<div class="kpost-thankyou">
			<?php echo $this->messageButtons->get('thankyou'); ?>
		</div>
	<?php endif; ?>


	<?php if($this->messageButtons->get('unthankyou')): ?>
		<div class="kpost-unthankyou">
			<?php echo $this->messageButtons->get('unthankyou'); ?>
		</div>
	<?php endif; ?>
</div>

<?php if(!empty($this->thankyou)): ?>
	<div class="kmessage-thankyou">
		<?php
			echo JText::_('COM_KUNENA_THANKYOU').': '.implode(', ', $this->thankyou).' ';
			if ($this->more_thankyou) echo JText::sprintf('COM_KUNENA_THANKYOU_MORE_USERS',$this->more_thankyou);
		?>
	</div>
<?php endif; ?>
