<?php
/**
 * Kunena Component
 * @package Kunena.Template.Blue_Eagle
 * @subpackage Topics
 *
 * @copyright (C) 2008 - 2016 Kunena Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.kunena.org
 **/
defined ( '_JEXEC' ) or die ();

/*$jf_doc 			= JFactory::getDocument();
$jf_doc->addScriptDeclaration('alert("RESULT = topics/default_row.php");');*/
require_once dirname(__FILE__).'/../../jf/jf_ku_page_topics.php';
// Disable caching
$this->cache = false;

// Show one topic row
?>
<?php if ($this->spacing) : ?>
<tr class="hidden-phone">
	<td class="kcontenttablespacer hidden-phone" colspan="<?php echo empty($this->topicActions) ? 5 : 6 ?>">&nbsp;</td>
</tr>
<?php endif; ?>

<tr class="<?php echo $this->getTopicClass('k', 'row') ?>">

	<td class="kcol-first jf_ku_topics_list_avatar hidden-phone">
		<?php if (!empty($this->topic->avatar)) : ?>
			<?php echo $this->topic->getLastPostAuthor()->getLink( $this->topic->avatar ) ?>
		<?php endif; ?>
	</td>

	<td class="kcol-mid jf_ku_topics_details">
		
		<?php if ($this->topic->attachments) echo $this->getIcon ( 'ktopicattach', JText::_('COM_KUNENA_ATTACH') ); ?>
		<?php if ($this->topic->poll_id) echo $this->getIcon ( 'ktopicpoll', JText::_('COM_KUNENA_ADMIN_POLLS') ); ?>

		<div class="jf_ku_topics_list_head">
			<?php if ($this->topic->unread) : ?>
				<?php echo $this->getTopicLink ( $this->topic, 'unread', $this->topic->getIcon() ) ?>
			<?php else :  ?>
				<?php echo $this->getTopicLink ( $this->topic, null , $this->topic->getIcon() ) ?>
			<?php endif;?>
			<?php
			if ($this->topic->unread) {
				echo $this->getTopicLink ( $this->topic, 'unread', $this->topic->subject . '<sup dir="ltr" class="knewchar">(' . $this->topic->unread . ' ' . JText::_('COM_KUNENA_A_GEN_NEWCHAR') . ')</sup>', null, 'ktopic-title km' );
			}
			else
			{
				echo $this->getTopicLink ( $this->topic, null, null, JText::sprintf('COM_KUNENA_CATEGORY_X', $this->topic->getCategory() ), 'ktopic-title km' );
			}
			if ($this->topic->getUserTopic()->favorite) {
				echo $this->getIcon ( 'kfavoritestar', JText::_('COM_KUNENA_FAVORITE') );
			}
			if ($this->me->exists() && $this->topic->getUserTopic()->posts) {
				echo $this->getIcon ( 'ktopicmy', JText::_('COM_KUNENA_MYPOSTS') );
			}

			?>
		</div>

		<div class="jf_ku_topics_list_text">
			<?php echo KunenaHtmlParser::stripBBCode ( $this->topic->first_post_message, 150); ?>
		</div>

		<?php if (!empty($this->keywords)) : ?>
		<div class="ktopic-keywords">
			<?php echo JText::sprintf('COM_KUNENA_TOPIC_TAGS', $this->escape($this->keywords)) ?>
		</div>
		<?php endif; ?>
		
		
		<div class="jf_ku_topics_list_footer">
			<span class="jf_ku_ktopic_by"><?php echo JText::_('COM_KUNENA_BY') . ' ' . $this->topic->getFirstPostAuthor()->getLink(null, null, 'nofollow', '', null, $this->topic->getCategory()->id) ?></span>
			<span class="jf_ku_ktopic_posted_time" title="<?php echo KunenaDate::getInstance($this->topic->first_post_time)->toKunena('config_post_dateformat_hover'); ?>">
				<?php echo KunenaDate::getInstance($this->topic->first_post_time)->toKunena('config_post_dateformat');?>
			</span>
			<span class="jf_ku_ktopic_latest_post">
			<?php
				echo $this->getTopicLink ( $this->topic, 'last', JText::_('COM_KUNENA_GEN_LAST_POST') );
				echo ' ' . JText::_('COM_KUNENA_BY') . ' ' . $this->topic->getLastPostAuthor()->getLink(null, null, 'nofollow', '', null, $this->topic->getCategory()->id);
			?>
			</span>
			<span class="jf_ku_ktopic_latest_post_date" title="<?php echo KunenaDate::getInstance($this->topic->last_post_time)->toKunena('config_post_dateformat_hover'); ?>">
				<?php echo KunenaDate::getInstance($this->topic->last_post_time)->toKunena('config_post_dateformat'); ?>
			</span>
			<?php if ($this->pages > 1) : ?>
				<ul class="jf_ku_ktopic_pagination">
					<li class="page"><?php echo JText::_('COM_KUNENA_PAGE') ?></li>
					<li><?php echo $this->GetTopicLink ( $this->topic, 0, 1 ) ?></li>
					<?php if ($this->pages > 4) : $startPage = $this->pages - 3; ?>
					<li class="more">...</li>
					<?php else: $startPage = 1; endif;
					for($hopPage = $startPage; $hopPage < $this->pages; $hopPage ++) : ?>
					<li><?php echo $this->getTopicLink ( $this->topic, $hopPage, $hopPage+1 ) ?></li>
					<?php endfor; ?>
				</ul>
			<?php endif; ?>
			<div class="jf_ku_ktopic_stat">
				<span><?php echo $this->formatLargeNumber ( max(0,$this->topic->getTotal()-1) ); ?> <?php echo JText::_('COM_KUNENA_GEN_REPLIES') ?></span>
				<span><?php echo $this->formatLargeNumber ( $this->topic->hits );?> <?php echo JText::_('COM_KUNENA_GEN_HITS');?> </span>
			</div>
		</div>
	</td>

<?php if (!empty($this->topicActions)) : ?>
	<td class="kcol-mid ktopicmoderation"><input class ="kcheck" type="checkbox" name="topics[<?php echo $this->topic->id?>]" value="1" /></td>
<?php endif; ?>
</tr>
<!-- Module position -->
<?php if ($this->module) : ?>
<tr>
	<td class="ktopicmodule" colspan="<?php echo empty($this->topicActions) ? 5 : 6 ?>"><?php echo $this->module; ?></td>
</tr>
<?php endif; ?>
